package alg;

import java.io.*;
import java.util.*;

public class Train {

  static int n;                    // number of carriages in the depot
  static int [] carriageMass;     
  static boolean [] carriageFree;  // [i] true iff cariage i is in the train
  static boolean [][] canFollow;   // [i][j] true iff i can be followed by j
  static int [] train;             //  [i] contains id of carriage at pos i in the train
  static int trainMass = 0;        //  initial value;
  static int [] bestTrain;         //  the train best so far in the same format as train
  static int bestTrainMass = 0;
  static int bestTrainLength = 1;  // includes engine

static void readAll() throws IOException {
  BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
  n = Integer.valueOf(br.readLine());
  bestTrain = new int [n+1];
  train = new int[n+1];
  canFollow = new boolean [n+1][n+1];
  carriageMass = new int[n+1];
  carriageFree = new boolean[n+1];
  int carriageId, prevCarriageId ;
  for (int i = 1; i <= n; i++) {
    StringTokenizer st = new StringTokenizer(br.readLine());
    carriageId = Integer.valueOf(st.nextToken());
    carriageMass[carriageId] = Integer.valueOf(st.nextToken());
    carriageFree[carriageId] = true;
    while(st.hasMoreTokens()) {
       prevCarriageId =Integer.valueOf(st.nextToken());
      canFollow[prevCarriageId][carriageId] = true;
    }
  }
}

static void listBestTrain() {
 for(int i = 0; i < bestTrainLength; i++)
    System.out.printf("%d ", bestTrain[i]);
  System.out.printf("\n%d\n", bestTrainMass);
  System.exit(0);  // end of the story
}

static void tryAppendCarriageAtPos(int pos){
  if (trainMass > bestTrainMass) {        // is this the best train so far?
    bestTrainMass = trainMass;            // register it
    for(int i = 1; i < pos; i++)          // up to position pos-1 obviously
      bestTrain[i] = train[i];
    bestTrainLength = pos;
  }
  if (pos == n+1)                         // all carriages are in the train
    listBestTrain();                      // also terminates the program
  for(int icarr = 1; icarr <= n; icarr++)
    if ((canFollow[train[pos-1]][icarr] ) && (carriageFree[icarr])) {
      train[pos] = icarr;                 // append the carriage
      trainMass += carriageMass[icarr];   // train mass increases
      carriageFree[icarr] = false;        // carriage is being used
         tryAppendCarriageAtPos(pos+1);
      carriageFree[icarr] = true;         // free the carriage
      trainMass -= carriageMass[icarr];   // reset the train mass
    }                                     // de-append is managed by recursion itself
 }

public static void main(String[] args) throws IOException{
    readAll();
    tryAppendCarriageAtPos(1);            // engine is at position 0.
    listBestTrain();
}
}
